# TRL-export-civ5
 Export icon sheets in the format expected by Civilization V.
 
 Recommended template for making Icon Atlases: https://forums.civfanatics.com/resources/icon-atlas-templates-for-the-gimp-xcf-format.15498/
 
 > **Note**: Requires GIMP 2.10+, or Shawn Kirst's DDS plugin for GIMP 2.9 (or lower).
 
 > **Note**: Not supported for GIMP 3+

## Features
- Specify Icon Size of the base sheet
- Choose Export Filename & Directory
- Select Icon Sizes to export to
- (optional) Compress Icon Sheets
- (optional) Generate IconAtlases
- (optional) Resize Icon Sheets

The plugin can be launched from File > Export Civ5 Icons...

## Installation
1. Open GIMP
2. Go to Edit > Preferences
3. Go to Folders > Plug-ins
4. Navigate to the first folder listed there, and paste a copy of the script (trl-export-civ5.py) in there.
5. Relaunch GIMP

<img src="Screenshots/plugin_folder.PNG" width="650px" alt="Plugin Folder">
 
## Useful References for GIMP Plugin Development
**Python/Python-Fu Plugin Templates** (By Herbie):
http://gimpchat.com/viewtopic.php?f=9&t=18401

**PYTHON-FU PLUGIN SAMPLES** (By Ofnuts):
https://sourceforge.net/projects/gimp-tools/files/scripts/

**PyGTK 2.0 Reference Manual**:
https://developer.gnome.org/pygtk/stable/

**GIMP 2.8.7 Library Reference Manual** (for C):
https://developer.gimp.org/api/2.0/libgimp/index.html

**GIMP 2.10 Source Code (dds plugin)**:
https://gitlab.gnome.org/GNOME/gimp/-/blob/gimp-2-10/plug-ins/file-dds/dds.c

### Storing an Image in a Plugin File
Images can be stored as an array directly in a file to be used by GTK. This is currently done for the Tibs image. Generating such an array can be done as follows:
1. Start a session at https://cocalc.com/
2. Upload an image file: "tibs.png" (Files > Upload)
3. `gdk-pixbuf-csource tibs.png | sed -n -e 's/{/[/' -e 's/};/]/' -e '/".*"/p'`
4. Copy the output (data) and replace the square brackets by round ones
5. `gdk-pixbuf-csource tibs.png | sed -n -e 's/{/[/' -e 's/};/]/' -e '/".*"/p' > tibs.c`
6. wc -c < tibs.c
7. Copy the output (which represents the bytelength of the data)
